BEGIN{
    current_mode = "";
    row = 0;
    col = 0;
    width = 0;
    height = 0;
    clear = "Y";
}
{
    rec = $0;
    if ($0 ~ /^\$/){
	current_mode = $0;
    }
    if (current_mode ~ /^\$GEOMETRY/){
	if ($0 ~ /^row */){
	    gsub(/^row */,"",rec);
	    gsub(/ .*$/,"",rec);
	    row = rec;
	}else if ($0 ~ /^col /){
	    gsub(/^col */,"",rec);
	    gsub(/ .*$/,"",rec);
	    col = rec;
	}else if ($0 ~ /^width /){
	    gsub(/^width */,"",rec);
	    gsub(/ .*$/,"",rec);
	    width = rec;
	}else if ($0 ~ /^height /){
	    gsub(/^height */,"",rec);
	    gsub(/ .*$/,"",rec);
	    height = rec;
	}else if ($0 ~ /^clear /){
	    gsub(/^clear */,"",rec);
	    gsub(/ .*$/,"",rec);
	    clear = rec;
	}
    }
}
END{
    printf("G %03d %03d %03d %03d %s\n", col, row, width, height, clear);
}
