BEGIN{
    screen_name = "";
    current_mode = "";
    row = 0;
    col = 0;
    len = 0;
    c_cnt = 0;
}
{
    rec = $0;
    if (screen_name == ""){
        screen_name = FILENAME;
        gsub(/\.src$/, "", screen_name);
    }

    if ($0 ~ /^\$/){
	current_mode = $0;
    }
    if (current_mode ~ /^\$IOCHAR/){
	if ($0 ~ /^input/){
	    gsub(/^input */,"",rec);
	    inchar1 = substr(rec, 1, 1);
	    gsub(/^. */,"",rec);
	    inchar2 = substr(rec, 1, 1);
	}else if ($0 ~ /^output/){
	    gsub(/^output */,"",rec);
	    outchar1 = substr(rec, 1, 1);
	    gsub(/^. */,"",rec);
	    outchar2 = substr(rec, 1, 1);
	}else if ($0 ~ /^select/){
	    gsub(/^select */,"",rec);
	    selchar1 = substr(rec, 1, 1);
	    gsub(/^. */,"",rec);
	    selchar2 = substr(rec, 1, 1);
	}
    }else if (current_mode ~ /^\$SCREEN/){
	if ($0 ~ /^\$SCREEN/){
	    ;
	}else{
	    reclen = length($0);
	    col = 0;
	    while(col < reclen){
		ch = substr($0, col+1, 1);
		if (ch == " " ){
		    col++;
		}else if (ch == inchar1 || ch == inchar2){
		    len = 0;
		    while (ch == substr($0, col+1,1) &&
			   col < reclen){
			len++;
			col++;
		    }
		}else if (ch == outchar1 || ch == outchar2){
		    len = 0;
		    while (ch == substr($0, col+1,1) &&
			   col < reclen){
			len++;
			col++;
		    }
		}else if (ch == selchar1 || ch == selchar2){
		    len = 0;
		    while (ch == substr($0, col+1,1) &&
			   col < reclen){
			len++;
			col++;
		    }
		}else{
		    len = 0;
		    while (ch != inchar1  && ch != inchar2 &&
			   ch != outchar1 && ch != outchar2 &&
			   ch != selchar1 && ch != selchar2 &&
			   ch != " " && col < reclen){
			len++;
			col++;
			ch = substr($0, col+1,1);
		    }
		    printf("#define %s_const%d\n", screen_name, ++c_cnt);
		}
	    }
	    row++;
	}
    }else if (current_mode ~ /^\$ITEM/){
	if ($0 ~ /^\$ITEM/){
	    ;
	}else{
	    reclen = length($0);
	    col = 0;
	    while(col < reclen){
		ch = substr($0, col+1, 1);
		if (ch == " " ){
		    col++;
		}else{
		    len = 0;
		    col_save = col;
		    while (substr($0, col+1,1) != " " &&
			   col < reclen){
			len++;
			col++;
		    }
		    printf("#define %s_%s\n", screen_name,
			   substr($0, col_save+1, len));
		}
	    }
	}
    }
}
END{
}
